HDU 1240 Asteroids!(BFS)

题目链接

Problem Description

You‘re in space.
You want to get home.
There are asteroids.
You don‘t want to hit them.

Input

Input to this problem will consist of a (non-empty) series of up to 100 data sets. Each data set will be formatted according to the following description, and there will be no blank lines separating data sets.

A single data set has 5 components:
Start line - A single line, "START N", where 1 <= N <= 10.
Slice list - A series of N slices. Each slice is an N x N matrix representing a horizontal slice through the asteroid field. Each position in the matrix will be one of two values:
‘O‘ - (the letter "oh") Empty space
‘X‘ - (upper-case) Asteroid present
Starting Position - A single line, "A B C", denoting the <A,B,C> coordinates of your craft‘s starting position. The coordinate values will be integers separated by individual spaces.
Target Position - A single line, "D E F", denoting the <D,E,F> coordinates of your target‘s position. The coordinate values will be integers separated by individual spaces.
End line - A single line, "END"
The origin of the coordinate system is <0,0,0>. Therefore, each component of each coordinate vector will be an integer between 0 and N-1, inclusive.
The first coordinate in a set indicates the column. Left column = 0.
The second coordinate in a set indicates the row. Top row = 0.
The third coordinate in a set indicates the slice. First slice = 0.
Both the Starting Position and the Target Position will be in empty space.

Output

For each data set, there will be exactly one output set, and there will be no blank lines separating output sets.

A single output set consists of a single line. If a route exists, the line will be in the format "X Y", where X is the same as N from the corresponding input data set and Y is the least number of moves necessary to get your ship from the starting position to the target position. If there is no route from the starting position to the target position, the line will be "NO ROUTE" instead.

A move can only be in one of the six basic directions: up, down, left, right, forward, back. Phrased more precisely, a move will either increment or decrement a single component of your current position vector by 1.

Sample Input

START 1

O

0 0 0

0 0 0

END

START 3

XXX

XXX

XXX

OOO

OOO

OOO

XXX

XXX

XXX

0 0 1

2 2 1

END

START 5

OOOOO

OOOOO

OOOOO

OOOOO

OOOOO

OOOOO

OOOOO

OOOOO

OOOOO

OOOOO

XXXXX

XXXXX

XXXXX

XXXXX

XXXXX

OOOOO

OOOOO

OOOOO

OOOOO

OOOOO

OOOOO

OOOOO

OOOOO

OOOOO

OOOOO

0 0 0

4 4 4

END

Sample Output

1 0

3 4

NO ROUTE

题解:

首先庆祝一下打破了这题提交4444次的记录==

?

言归正传,好长的input...看晕了。

好了,再次言归正传→_→,题意是给出一个N,然后给出任意数量包含N个‘X’或‘O’的行(前3*N行是有效行),以‘END’结尾,我还一直纳闷END有什么用。然后给两个坐标,分别是起点和终点。这个坐标要注意按顺序是列,行,维度(起始都是0),所以定义点坐标是x,y,z时,输入读取的顺序是z,y,x,否则第二个测试数据答案会是无解(说不清楚看代码)。

#include <cstdio>
#include <iostream>
#include <string>
#include <sstream>
#include <cstring>
#include <stack>
#include <queue>
#include <algorithm>
#include <cmath>
#include <map>
#define PI acos(-1.0)
#define ms(a) memset(a,0,sizeof(a))
#define msp memset(mp,0,sizeof(mp))
#define msv memset(vis,0,sizeof(vis))
using namespace std;
//#define LOCAL
int n,m;
struct Node
{
    int x,y,z;
    int step;
}sp,ep,cp;
char mp[12][12][12];
int dir[6][3]={{0,1,0},{0,-1,0},{-1,0,0},{1,0,0},{0,0,1},{0,0,-1}};
int bfs()
{
    queue<Node> q;
    while(!q.empty())q.pop();
    q.push(sp);
    while(!q.empty())
    {
        sp=q.front(),q.pop();
        if(sp.x==ep.x&&sp.y==ep.y&&sp.z==ep.z)return sp.step;
        for(int i=0;i<6;i++)
        {
            cp.x=sp.x+dir[i][0];
            cp.y=sp.y+dir[i][1];
            cp.z=sp.z+dir[i][2];
            cp.step=sp.step+1;
            if(mp[cp.x][cp.y][cp.z]==‘X‘)continue;
            if(cp.x<0||cp.y<0||cp.z<0||cp.x>=n||cp.y>=n||cp.z>=n)continue;
            mp[cp.x][cp.y][cp.z]=‘X‘;
            q.push(cp);
        }
    }
    return -1;
}
int main()
{
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif // LOCAL
    ios::sync_with_stdio(false);
    char t[10];
    while(cin>>t>>n)
    {
        m=0;
        for(int i=0;i<n;i++)
        for(int j=0;j<n;j++)
        cin>>mp[i][j];
        cin>>sp.z>>sp.y>>sp.x;//x-col,y-raw,z-dim
        cin>>ep.z>>ep.y>>ep.x;
        sp.step=0,ep.step=0;
        mp[sp.x][sp.y][sp.z]=‘X‘;
        int ans=bfs();
        if(ans==-1)printf("NO ROUTE\n");
        else printf("%d %d\n",n,ans);
        while(cin>>t)if(t[0]==‘E‘)break;
    }
    return 0;
}
时间: 2024-12-08 18:06:57

HDU 1240 Asteroids!(BFS)的相关文章

hdu 1240:Asteroids!(三维BFS搜索)

Asteroids! Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 3159    Accepted Submission(s): 2106 Problem Description You're in space.You want to get home.There are asteroids.You don't want to hit

HDU 1240——Asteroids!(三维BFS)POJ 2225——Asteroids

普通的三维广搜,需要注意的是输入:列,行,层 #include<iostream> #include<cstdio> #include<cstring> #include<queue> #include<algorithm> #define M 11 using namespace std; int dir[6][3]={{0,1,0},{0,-1,0},{1,0,0},{-1,0,0},{0,0,1},{0,0,-1}};//6个方向 int

HDU 1240 Asteroids! (三维BFS)

Asteroids! Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 4749    Accepted Submission(s): 3048 Problem Description You're in space. You want to get home. There are asteroids. You don't want to

HDU 1240 Asteroids!【BFS】

题意:给出一个三维的空间,给出起点和终点,问是否能够到达终点 和上一题一样,只不过这一题的坐标是zxy输入的, 因为题目中说的是接下来的n行中分别是由n*n的矩形组成的,所以第一个n该是Z坐标,n*n的矩形为底面,为x,y坐标 -----还是注意输入的方式--- #include<iostream> #include<cstdio> #include<cstring> #include<algorithm> #include<queue> #de

HDU 1240.Asteroids!

Asteroids! Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u SubmitStatusPracticeHDU 1240 Description You're in space. You want to get home. There are asteroids. You don't want to hit them. Input Input to this problem will

HDU 1240 Asteroids! 解题报告

//这道题做完我只有 三个感受  第一:坑: 第二 : 坑! 第三:还是坑! 咳咳  言归正传  WA了无数次之后才发现是输入进去时坐标时z, y, x的顺序输入的 题解   :  类似胜利大逃亡 只不过给你了起始坐标和终点坐标, 让你输出到达目标点所需最少步数: 输出时第一个输出时是START读入的map大小值n;第二个是所求步数 //细节: 1.读入:   读入时分别两次%S把没用的START 和 END读取掉: 2.输出时输出 三维坐标大小值n, 以及步数: 3.输入进去时开始点和结束点坐

HDU 1240 (简单三维广搜) Asteroids!

给出一个三维的迷宫以及起点和终点,求能否到大终点,若果能输出最短步数 三维的问题无非就是变成了6个搜索方向 最后强调一下xyz的顺序,从输入数据来看,读入的顺序是map[z][x][y] 总之,这是很基础的一道题 1 //#define LOCAL 2 #include <iostream> 3 #include <cstdio> 4 #include <cstring> 5 #include <queue> 6 #include <algorithm

HDOJ 1240 Asteroids!

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1240 Asteroids! Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 3643    Accepted Submission(s): 2413 Problem Description You're in space. You want

[ACM] hdu 1242 Rescue (BFS+优先队列)

Rescue Problem Description Angel was caught by the MOLIGPY! He was put in prison by Moligpy. The prison is described as a N * M (N, M <= 200) matrix. There are WALLs, ROADs, and GUARDs in the prison. Angel's friends want to save Angel. Their task is: